'''
  ____    _    ____      _    
 / ___|  / \  |  _ \    / \   
 \___ \ / _ \ | |_) |  / _ \  
  ___) / ___ \|  _ <  / ___ \ 
 |____/_/   \_\_| \_\/_/   \_\

Script to set the URL for a HTTP request
Ex:
/usr/bin/python3 /var/www/moduleair_pro_4g/SARA/sara_setURL.py ttyAMA2 data.moduleair.fr 0
To do: need to add profile id as parameter

First profile id:
    AT+UHTTP=0,1,"data.moduleair.fr"
Second profile id:
    AT+UHTTP=1,1,"api-prod.uspot.probesys.net"
'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
#print("Parameters received:")
port='/dev/'+parameter[0] # ex: ttyAMA2
url = parameter[1]  # ex: data.mobileair.fr
profile_id = parameter[2] #ex: 0

ser = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=115200, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)

command = f'AT+UHTTP={profile_id},1,"{url}"\r'
ser.write((command + '\r').encode('utf-8'))

print("****")
print("SET URL (SARA)")

try:
    # Read lines until a timeout occurs
    response_lines = []
    while True:
        line = ser.readline().decode('utf-8').strip()
        if not line:
            break  # Break the loop if an empty line is encountered
        response_lines.append(line)

    # Print the response
    for line in response_lines:
        print(line)

except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser.is_open:
        ser.close()
        print("****")
        #print("Serial closed")

